SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'SebastianGarbi 4/29/2013 19:28'!
blueGhost

	^(BlueGhost new).! !

!PacManTest methodsFor: 'actors' stamp: 'SebastianGarbi 4/29/2013 19:50'!
blueberry

	^(Blueberry new).! !

!PacManTest methodsFor: 'movements' stamp: 'SebastianGarbi 4/29/2013 20:07'!
down

	^(0@ -1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'SebastianGarbi 4/29/2013 20:12'!
ghostHouseDoorType

	^(GhostHouseDoorType new)! !

!PacManTest methodsFor: 'movements' stamp: 'SebastianGarbi 4/29/2013 20:07'!
left

	^(-1@0).! !

!PacManTest methodsFor: 'construction block types' stamp: 'SebastianGarbi 4/29/2013 20:31'!
leftTransporterType

	^LeftTransporterType new.! !

!PacManTest methodsFor: 'actors' stamp: 'SebastianGarbi 4/29/2013 19:37'!
pacman

	^(PacMan new).! !

!PacManTest methodsFor: 'movements' stamp: 'SebastianGarbi 4/29/2013 20:07'!
right

	^(1@0). ! !

!PacManTest methodsFor: 'construction block types' stamp: 'SebastianGarbi 4/29/2013 20:10'!
spaceType

	^(SpaceType new). 
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'SebastianGarbi 4/29/2013 20:05'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'SebastianGarbi 4/29/2013 20:07'!
up

	^(0@1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'SebastianGarbi 4/29/2013 19:31'!
wallType

	^(WallType new).! !

Object subclass: #BloqueType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

BloqueType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 4/29/2013 21:53'!
nextPositionFor: aPersonajeQueSeMueve going: aPoint 
^aPersonajeQueSeMueve nextPositionMovingInto: self going: aPoint 
"|aReglaDeMovimiento|
ReglasDeMovimientoDePersonajeQueSeMueve dameReglasDe: aPersonajeQueSeMueve 

^aPersonajeQueSeMueve movingToGhostDoorHouseType: aPoint"
"	(aPersonajeQueSeMueve isKindOf:  PacMan)
	ifTrue: [^aPersonajeQueSeMueve position].
	^aPersonajeQueSeMueve position + aPoint"
"	nextPositionWhenMovingInto: aConstructionBlockType going: aDirection"! !

BloqueType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'wt' stamp: 'SebastianGarbi 4/29/2013 21:55'!
nextPositionFor: aPersonajeQueSeMueve going: aPoint 
	^aPersonajeQueSeMueve position .! !

Object subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 4/29/2013 20:34'!
nextPositionFor: aPersonajeQueSeMueve going: aPoint 
	(aPersonajeQueSeMueve isKindOf:  PacMan)
	ifTrue: [^(3@10)].
	(aPersonajeQueSeMueve isKindOf:  Blueberry )
	ifTrue: [^(5@10)].
	^aPersonajeQueSeMueve position! !

Object subclass: #PersonajeQueSeMueve
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

PersonajeQueSeMueve subclass: #BlueGhost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlueGhost methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 4/29/2013 21:39'!
movingToGhostDoorHouseType: aPoint 
	^self position + aPoint! !

PersonajeQueSeMueve subclass: #Blueberry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Blueberry methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 4/29/2013 21:39'!
movingToGhostDoorHouseType: aPoint 
	^self position + aPoint! !

PersonajeQueSeMueve subclass: #PacMan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacMan methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 4/29/2013 21:39'!
movingToGhostDoorHouseType: aPoint 
	^self position! !

!PersonajeQueSeMueve methodsFor: 'pqsm' stamp: 'SebastianGarbi 4/29/2013 19:42'!
position
	^(0@0).! !

Object subclass: #ReglasDeMovimientoDePersonajeQueSeMueve
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

ReglasDeMovimientoDePersonajeQueSeMueve subclass: #ReglasDeMovimientoDeBlueGhost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

ReglasDeMovimientoDePersonajeQueSeMueve subclass: #ReglasDeMovimientoDeBlueberry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

ReglasDeMovimientoDePersonajeQueSeMueve subclass: #ReglasDeMovimientoDePacMan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!ReglasDeMovimientoDePersonajeQueSeMueve methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 4/29/2013 21:28'!
dondeQuedariaSi: aPersonajeQueSeMueve seMueveA: aBloqueType enDireccion: aPoint
 ^ self shouldBeImplemented ! !

Object subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 4/29/2013 20:06'!
nextPositionFor: aPersonajeQueSeMueve going: aPoint 
	^(aPersonajeQueSeMueve position + aPoint)! !
